close all
clear all

eFname = '';

fid = uipickfiles('FilterSpec','');

    e = actxserver('Excel.Application');
    e.Visible = 0;  
    e.DisplayAlerts = 0;

    eWorkbook = e.Workbooks.Open(eFname);
    
%     tokens = regexp(fid{1}, '(\d+)\.(\d+)', 'tokens', 'once');
    
    prompt = {'Participant ID:','Observation:'};
    dlg_title = 'Input';
    num_lines = 1;
%     defaultans = {tokens{1},'0'};
    defaultans = {'0','0'};
    answer = inputdlg(prompt,dlg_title,num_lines,defaultans);
    
    ID = str2double(answer{1});
    Observation = str2double(answer{2});

    h = waitbar(0,'Please wait...');  
    
    row = num2str(ID + 4);
    rowD = ID + 4;
    
    eSheet = eWorkbook.Sheets.get('Item',1);
    eSheet.Activate
    
    eActivesheetRange = get(eSheet,'Range',['D' num2str(row)]);
    Affected  = eActivesheetRange.Value;
    
    if isnan(Affected)   
        eActivesheetRange = get(eSheet,'Range',['F' num2str(row)]);
        Affected  = eActivesheetRange.Value;
    end
  
    
for j = 1 : size(fid,2)

    [num,txt,raw] = xlsread(fid{j});

    
    OpenBracket = strfind(fid{j},'(');
    ClosedBracket = strfind(fid{j},')');
    Task = str2double(fid{j}(OpenBracket+1:ClosedBracket-1));
    
    d = str2double(raw);

    SensorOne = d(3:size(d,1),1:4);
    SensorOne(:,5) = d(3:size(d,1),9);
    SensorTwo = d(3:size(d,1),10:13);
    SensorTwo(:,5) = d(3:size(d,1),18);
    SensorThree = d(3:size(d,1),19:22);
    SensorThree(:,5) = d(3:size(d,1),27);

    SensorOneE = zeros(size(SensorOne,1),5);
    SensorTwoE = zeros(size(SensorTwo,1),5);
    SensorThreeE = zeros(size(SensorThree,1),5);

    for i = 1 : size(SensorOne,1)  %Calculate Excursion. Sort Time variable

        SensorOneE(i,:) = SensorOne(i,:) - SensorOne(1,:);
        SensorTwoE(i,:) = SensorTwo(i,:) - SensorTwo(1,:);
        SensorThreeE(i,:) = SensorThree(i,:) - SensorThree(1,:);

    end

    if Task == 1 || Task == 2;
         Task_1_2(SensorThreeE,row,Affected,Observation,Task,eWorkbook)
    end

    if Task == 3;
         Task_3(SensorTwoE,SensorThreeE,row,Affected,Observation,Task,eWorkbook)
    end 
    
    if Task >= 4 && Task <=9;
         Task_4_9(SensorThreeE,row,Affected,Observation,Task,eWorkbook)
    end 
      
    if Task >= 10 && Task <= 13;
         Task_10_13(SensorOneE,SensorThreeE,row,Affected,Observation,Task,eWorkbook)
    end 
    
    if Task == 14 || Task == 15
         Task_14_17(SensorThreeE,rowD,Affected,Observation,Task,eWorkbook)
    end   
    
    if Task == 16 || Task == 17
         Task_14_17(SensorOneE,rowD,Affected,Observation,Task,eWorkbook)
    end 
   
    clearvars -except j h fid ID Observation e eWorkbook eFname row Affected rowD
    
    waitbar(j/size(fid,2),h);
    
end

close(h)

invoke(eWorkbook, 'SaveAs', eFname);
invoke(e, 'Quit');
delete(e);
clear all